package com.planetmyanmarnews;

import com.deaux.fan.FanView;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.Html;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

public class About extends Activity {
	
	private ListView sideMenuList;
	private FanView fan;
	
	private TextView txt1;
	private ImageView btnSlide, btnShare;
	private String aboutMessage;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.common);
        fan = (FanView) findViewById(R.id.fan_view);
        fan.setViews(R.layout.about, R.layout.sidemenu);

        sidemenu[] sidemenu_data = common.sideMenuData();
        
        sidemenuadapter adapter = new sidemenuadapter(this, R.layout.listview_item_row, sidemenu_data);
        
        sideMenuList = (ListView)findViewById(R.id.listView1);                 
        sideMenuList.setAdapter(adapter);
        sideMenuList.setOnItemClickListener(new OnItemClickListener() {
        	public void onItemClick(AdapterView<?> a, View v, int position, long id) {        		
        		sidemenu item = (sidemenu) a.getItemAtPosition(position);        		
        		Intent myIntent = common.reDirect(item.title, About.this);
        		startActivity(myIntent);
        	}  
        });        
        
        ViewGroup tabBar = (ViewGroup) findViewById(R.id.tabBar_ref);
        btnSlide = (ImageView) tabBar.findViewById(R.id.BtnSlide);
        
        btnSlide.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		fan.showMenu();
        	}
        });

        txt1 = (TextView) findViewById(R.id.textView1);        
        aboutMessage = getResources().getString(R.string.about);
        txt1 = (TextView) findViewById(R.id.textView1);
        txt1.setText(Html.fromHtml(aboutMessage));				        

        btnShare = (ImageView) tabBar.findViewById(R.id.btnShare);
        btnShare.setVisibility(View.INVISIBLE);        
        
    }
     
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
			Intent intent = new Intent();
    		intent.setClass(About.this, MainActivity.class);
    		startActivity(intent);       		
	    }
	    return false;
	}
	
	public boolean onKeyUp(int keyCode, KeyEvent event) {
	    if (keyCode == KeyEvent.KEYCODE_MENU) {
	    	fan.showMenu();  	    	
	    }
	    return true;
	}  	
}
