package com.planetmyanmarnews;

import java.util.Calendar;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.database.Cursor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.Window;
import android.widget.TextView;

public class Index extends Activity {
	
	public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_LASTSID = "PrefLastID";
    
	private SharedPreferences mPrefs;
	private String lastrecordfromlocal;
	private TextView lastUpdated;
	
	DatabaseUtil dbUtil = new DatabaseUtil(this);       
    
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);                      
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.index);
        lastUpdated = (TextView) findViewById(R.id.txtLastUpdated);               
        
        mPrefs = getSharedPreferences(PREFS_NAME, 0);        
        
        try {
	        dbUtil.open();         
	        	Cursor cursor = dbUtil.getlastRecord();
	        	lastrecordfromlocal = cursor.getString(0);
	        	lastUpdated.setText("Last updated on : " + cursor.getString(1));
	        	lastUpdated.setPadding(5, 2, 2, 3);
			dbUtil.close();
        } catch (Exception e1) {
        	lastrecordfromlocal = "0";
        }
        
		Editor e = mPrefs.edit();    		      		        		        	
			e.putString(PREF_LASTSID, lastrecordfromlocal);
		e.commit();
		
		new LoadNewsLists().execute(lastrecordfromlocal);
	}

	public class LoadNewsLists extends AsyncTask<String, String, String> {
		private String j;
		private ProgressDialog progressDialog;
		
	    protected void onPreExecute() {
	    	progressDialog = ProgressDialog.show(Index.this, "", "Loading..."); 
	    }
	    
	    @Override
	    protected String doInBackground(String... urls) {
	        Intent intents = new Intent(Index.this, SyncService.class);
	        PendingIntent pintent = PendingIntent.getService(Index.this, 0, intents, 0);
	        Calendar calendar = Calendar.getInstance();        
	        AlarmManager alarm = (AlarmManager)getSystemService(Context.ALARM_SERVICE);
	        alarm.setRepeating(AlarmManager.RTC_WAKEUP, calendar.getTimeInMillis(), 10*1000, pintent);	    	
	        return j;
	    }
	    
	    protected void onPostExecute(final String result) {
	    	progressDialog.dismiss();
    		Intent intent = new Intent();
    		intent.setClass(Index.this, MainActivity.class);
    		startActivity(intent);
	    	
	    }
	}
	
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
     		AlertDialog.Builder alt_setting = new AlertDialog.Builder(Index.this);
    		alt_setting.setMessage("Do you want to exit?")
    		.setCancelable(false)
    		.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				moveTaskToBack(true);
    			}
    		})
    		.setNegativeButton("No", new DialogInterface.OnClickListener() {
    			public void onClick(DialogInterface dialog, int id) {
    				dialog.cancel();
    			}
    		});
    		AlertDialog alert_setting = alt_setting.create();
    		alert_setting.show();
    		return true;
	    }
	    return false;
	}	
}