package com.planetmyanmarnews;

import com.deaux.fan.FanView;

import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.AdapterView.OnItemClickListener;

import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;

public class ReadNews extends FragmentActivity {	
    private MyAdapter mAdapter;
    private ViewPager mPager;

    private static String mydataarray[];
    private static String mydatastring;    
    
    private static int NUMBER_OF_PAGES;      
    private static int GetCurrentIndex;
	
    private static ImageLoader imgLoader;
	
	private ListView sideMenuList;
	private FanView fan;	
	
	private ImageView btnSlide, btnShare;
	public ProgressBar tabSync;
	
    public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_NEWSID = "PrefNewsID";
    public static final String PREF_LASTSID = "PrefLastID";
    private static SharedPreferences mPrefs;
    DatabaseUtil dbUtil = new DatabaseUtil(this);
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.common);
        fan = (FanView) findViewById(R.id.fan_view);
        fan.setViews(R.layout.readnews, R.layout.sidemenu);
        
        imgLoader = new ImageLoader(this);

        sidemenu[] sidemenu_data = common.sideMenuData();        
        sidemenuadapter adapter = new sidemenuadapter(this, R.layout.listview_item_row, sidemenu_data);
        
        sideMenuList = (ListView)findViewById(R.id.listView1);                 
        sideMenuList.setAdapter(adapter);
        sideMenuList.setOnItemClickListener(new OnItemClickListener() {
        	public void onItemClick(AdapterView<?> a, View v, int position, long id) {        		
        		sidemenu item = (sidemenu) a.getItemAtPosition(position);        		
        		Intent myIntent = common.reDirect(item.title, ReadNews.this);
        		startActivity(myIntent);
        	}  
        });        
        
        ViewGroup tabBar = (ViewGroup) findViewById(R.id.tabBar_ref);
        btnSlide = (ImageView) tabBar.findViewById(R.id.BtnSlide);
        
        btnSlide.setOnClickListener(new OnClickListener() {
        	public void onClick(View v) {
        		fan.showMenu();
        	}
        });   	        
        
    	mPrefs = getSharedPreferences(PREFS_NAME, 0);       
        
        btnShare = (ImageView) tabBar.findViewById(R.id.btnShare);
        btnShare.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		shareIt();
        	}
        });
		
		new LoadTask().execute(mPrefs.getString(PREF_NEWSID, ""));
    }         

    private class LoadTask extends AsyncTask<String, Integer, String> {
    	private String getcurrent;	
    	private String[] getcurrentid;    	
    	private ProgressDialog progressDialog;
    	
    	@Override
    	protected void onPreExecute() {
    		mAdapter = new MyAdapter(getSupportFragmentManager());
            mPager = (ViewPager) findViewById(R.id.pager);
    		mPrefs = getSharedPreferences(PREFS_NAME, 0);    		
    		progressDialog = ProgressDialog.show(ReadNews.this, "", "Loading...");
    	}

 	   @Override
 	   protected String doInBackground(String... params) {
 		   try {
 			   mydataarray = common.GetIDData(ReadNews.this, params[0]);
 			   NUMBER_OF_PAGES = mydataarray.length;
 		        
 		        for (int j = 0; j < NUMBER_OF_PAGES; j++) {
 		        	getcurrent = mydataarray[j].toString();
 		        	getcurrentid = getcurrent.toString().trim().split("\\^"); 
 			        if (Integer.parseInt(mPrefs.getString(PREF_NEWSID, "")) == Integer.parseInt(getcurrentid[0].toString())) {
 	        			GetCurrentIndex = j;
 	        		}
 		        }
 		        
 	        } catch (Exception e1) {
 	        	Log.v ("pid error", "Error " + e1.getMessage());
 	        }	
 	      return "" + NUMBER_OF_PAGES;
 	   }

	   @Override
	   protected void onPostExecute(String result) {
			mPager.setAdapter(mAdapter);
			mPager.setCurrentItem(GetCurrentIndex);		   
			progressDialog.dismiss();
	   }
    }    
    
	public boolean onKeyDown(int keyCode, KeyEvent event){
	    if(keyCode == KeyEvent.KEYCODE_BACK) {	    	
			Intent intent = new Intent();
    		intent.setClass(ReadNews.this, MainActivity.class);
    		startActivity(intent);       		
	    }
	    return false;
	}	
	
	public boolean onKeyUp(int keyCode, KeyEvent event) {
	    if (keyCode == KeyEvent.KEYCODE_MENU) {
	    	fan.showMenu();  	    	
	    }
	    return true;
	}
	
	public static class MyAdapter extends FragmentPagerAdapter {
        public MyAdapter(FragmentManager fm) {
        	super(fm);
        }
        @Override
        public int getCount() {
                return NUMBER_OF_PAGES-1;
        }
        @Override
        public Fragment getItem(int position) {
        	mydatastring = mydataarray[position];
        	String[] getShareid = mydatastring.toString().trim().split("\\^");
    		Editor e = mPrefs.edit();    		      		        		        	
    			e.putString(PREF_NEWSID, getShareid[0].toString());
    		e.commit();        	
        	return new DetailFragment(mydatastring, imgLoader);
        }
    }
	
    private void shareIt() {
    	Intent sharingIntent = new Intent(android.content.Intent.ACTION_SEND);
    	sharingIntent.setType("text/plain");
    	String shareBody = "http://www.planet.com.mm/news/read.cfm/id/" + mPrefs.getString(PREF_NEWSID, "");
    	sharingIntent.putExtra(android.content.Intent.EXTRA_SUBJECT, "Subject Here");
    	sharingIntent.putExtra(android.content.Intent.EXTRA_TEXT, shareBody);
    	startActivity(Intent.createChooser(sharingIntent, "Share via"));
    }		
}