package com.planetmyanmarnews;

import java.util.concurrent.ExecutionException;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.database.Cursor;
import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.IBinder;
import android.os.Vibrator;
import android.util.Log;

public class SyncService extends Service{
	private String lastrecordfromlocal;
	DatabaseUtil dbUtil = new DatabaseUtil(this);
	
	private SharedPreferences mPrefs;	
    public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_LASTSID = "PrefLastID";
    
    @Override
    public IBinder onBind(Intent arg0) {
        // TODO Auto-generated method stub
        return null;
    }
    	
	@Override
    public void onStart(Intent intent, int startId) {
        // TODO Auto-generated method stub
        super.onStart(intent, startId);   
        mPrefs = getSharedPreferences(PREFS_NAME, 0);
        
        if (common.isNetAvailable(this) == true) {
        	SyncTask InstallData = new SyncTask(this, mPrefs.getString(PREF_LASTSID, ""));
        	try {        		
				String mystring = InstallData.execute(mPrefs.getString(PREF_LASTSID, "")).get();
				if (mystring != null) {
					if (!mystring.equals("0")) {
						
				        try {
					        dbUtil.open();         
					        	Cursor cursor = dbUtil.getlastRecord();
					        	lastrecordfromlocal = cursor.getString(0);
							dbUtil.close();
				        } catch (Exception e1) {
				        	lastrecordfromlocal = "0";
				        }
				        
						Editor e = mPrefs.edit();    		      		        		        	
							e.putString(PREF_LASTSID, lastrecordfromlocal);
						e.commit();
						Vibrator v = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
						v.vibrate(300);
						showNotification(mystring);
					}					
				}				
			} catch (InterruptedException e) {
				Log.v("v1", "error 1");	
			} catch (ExecutionException e) {
				Log.v("v2", "error 2");
			}        	
        }        
        this.stopSelf();
    }    
    
	private void showNotification(String getCount) {
    			
		Notification notification = new Notification(R.drawable.newsplanet, "Updated news found", System.currentTimeMillis());    	
    	PendingIntent contentIntent = PendingIntent.getActivity(this, 0, new Intent(this, Index.class), 0);
    	notification.setLatestEventInfo(this, "Planet Myanmar News", getCount + " - news have been updated", contentIntent);    	
    	
    	NotificationManager notificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
    	notification.flags |= Notification.FLAG_AUTO_CANCEL;
		notificationManager.notify(0, notification);
		
		Uri noti = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
        Ringtone r = RingtoneManager.getRingtone(getApplicationContext(), noti);
        r.play();		
    }        
    
    @Override
    public void onDestroy() {
        super.onDestroy();
    }    
}
