package com.planetmyanmarnews;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONException;
import org.json.JSONObject;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.util.Log;

public class common {
	
    public static final String PREFS_NAME = "GetIDPref";    
    public static final String PREF_NEWSCATEGORY = "PrefNewsCategory";

    public static SharedPreferences getPrefs(Context context) {
        return context.getSharedPreferences(PREFS_NAME, 0);

    }
    public static void setMyStringPref(Context context, String value) {
        getPrefs(context).edit().putString(PREF_NEWSCATEGORY, value).commit();
    }

	public static String getInputStreamFromUrl(String url) {
		String content = null;
		try {
			HttpClient httpclient = new DefaultHttpClient();
		    HttpResponse response = httpclient.execute(new HttpGet(url));
		    HttpEntity resEntity = response.getEntity();
		    content = EntityUtils.toString(resEntity);
		    content = content.trim();
		}
		catch(Exception e){
			Log.e("log_tag", "Error in http connection " + e.toString());
		}
		return content;
	}
	
	public static Boolean isNetAvailable(Context con)  {		  
        try{
            ConnectivityManager connectivityManager = (ConnectivityManager) con.getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo wifiInfo = connectivityManager.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
            NetworkInfo mobileInfo = connectivityManager.getNetworkInfo(ConnectivityManager.TYPE_MOBILE);
            if (wifiInfo.isConnected() || mobileInfo.isConnected()) {
                return true;
            }
        }
        catch(Exception e){
           e.printStackTrace();
        }
        return false;
    }	

	public static JSONObject getJSONfromURL(String url, String param1){
		InputStream is = null;
		String result = "";
		JSONObject jArray = null;
		
		//http post
	    try{
            HttpClient httpclient = new DefaultHttpClient();
            HttpPost httppost = new HttpPost(url);
            List<NameValuePair> pairs = new ArrayList<NameValuePair>();
        	pairs.add(new BasicNameValuePair("newsid", param1));
        	httppost.setEntity(new UrlEncodedFormEntity(pairs));	            
            HttpResponse response = httpclient.execute(httppost);
            HttpEntity entity = response.getEntity();
            is = entity.getContent();

	    }catch(Exception e){
	            Log.e("log_tag", "Error in http connection "+e.toString());
	    }
	    
	  //convert response to string
	    try{
	      BufferedReader reader = new BufferedReader(new InputStreamReader(is,"utf8"),8);
	      StringBuilder sb = new StringBuilder();
	      String line = null;
	      while ((line = reader.readLine()) != null) {
	    	  sb.append(line + "\n");
	      }
	      is.close();
	      result = sb.toString();
	    }
	    catch(Exception e){
	    	Log.e("log_tag", "Error converting result " + e.toString());
	    }
	    
	    try{	    	
            jArray = new JSONObject(result);
	    }catch(JSONException e){
	            Log.e("log_tag", "Error parsing data " + e.toString());
	    }
    
	    return jArray;
	}
	
	public static String getDatafromURL(String url, String param1){
		InputStream is = null;
		String result = "";
		
		//http post
	    try{
            HttpClient httpclient = new DefaultHttpClient();
            HttpPost httppost = new HttpPost(url);
            List<NameValuePair> pairs = new ArrayList<NameValuePair>();
        	pairs.add(new BasicNameValuePair("newsid", param1));
        	httppost.setEntity(new UrlEncodedFormEntity(pairs));	            
            HttpResponse response = httpclient.execute(httppost);
            HttpEntity entity = response.getEntity();
            is = entity.getContent();

	    }catch(Exception e){
	            Log.e("log_tag", "Error in http connection "+e.toString());
	    }
	    
	  //convert response to string
	    try{
	      BufferedReader reader = new BufferedReader(new InputStreamReader(is,"utf8"),8);
	      StringBuilder sb = new StringBuilder();
	      String line = null;
	      while ((line = reader.readLine()) != null) {
	    	  sb.append(line + "\n");
	      }
	      is.close();
	      result = sb.toString();
	    }
	    catch(Exception e){
	    	result = "error";
	    }	    
	    return result;
	}		
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getImageNumber() {
		return imageNumber;
	}
	public void setImageNumber(int imageNumber) {
		this.imageNumber = imageNumber;
	}
	
	private String name ;
	private int imageNumber;

	public static String TransformString(String chgtext) {
		String convTxt = chgtext;
		convTxt = convTxt.replace("&quot;", "'");
		convTxt = convTxt.replace("&quot;", "'");
		convTxt = convTxt.replace("&ldquo;", "'");
		convTxt = convTxt.replace("&rdquo;", "'");
		convTxt = convTxt.replace("&nbsp;", " "); 		
		return convTxt;		
	}
	
	public static sidemenu[] sideMenuData() {
        sidemenu sidemenu_data[] = new sidemenu[]
        {
        	new sidemenu(R.drawable.home, "Home"),
        	new sidemenu(R.drawable.sideicon, "Business"),
        	new sidemenu(R.drawable.sideicon, "Entertainment"),
        	new sidemenu(R.drawable.sideicon, "Health"),
        	new sidemenu(R.drawable.sideicon, "Science"),
        	new sidemenu(R.drawable.sideicon, "Sports"),
        	new sidemenu(R.drawable.sideicon, "World"),
        	new sidemenu(R.drawable.about, "About")
        	        		
        };		 		
		return sidemenu_data;		
	}
	
	public static Intent reDirect (String tabName, Context ctx) {		
		Intent intent = null;		
		if (tabName.equals("Home")) {
			common.setMyStringPref(ctx, "NULL");
     		intent = new Intent();
    		intent.setClass(ctx, MainActivity.class);
    		return intent;
		} else if(tabName.equals("Business")) {
			common.setMyStringPref(ctx, tabName);			
			intent = new Intent();
    		intent.setClass(ctx, MainActivity.class);
    		return intent;
		} else if(tabName.equals("Entertainment")) {
			common.setMyStringPref(ctx, tabName);			
			intent = new Intent();
    		intent.setClass(ctx, MainActivity.class);
    		return intent;
		} else if(tabName.equals("Health")) {
			common.setMyStringPref(ctx, tabName);			
			intent = new Intent();
    		intent.setClass(ctx, MainActivity.class);
    		return intent;
		} else if(tabName.equals("Science")) {
			common.setMyStringPref(ctx, tabName);			
			intent = new Intent();
    		intent.setClass(ctx, MainActivity.class);
    		return intent;
		} else if(tabName.equals("Sports")) {
			common.setMyStringPref(ctx, tabName);			
			intent = new Intent();
    		intent.setClass(ctx, MainActivity.class);
    		return intent;
		} else if(tabName.equals("World")) {
			common.setMyStringPref(ctx, tabName);			
			intent = new Intent();
    		intent.setClass(ctx, MainActivity.class);
    		return intent;
		} else if(tabName.equals("About")) {
			intent = new Intent();
    		intent.setClass(ctx, About.class);
    		return intent;
		}		
		return intent;				
	}
	
	private static String pidlist[];
    protected static String[] GetIDData(Context ctx, String getid) {    	
    	DatabaseUtil dbUtil = new DatabaseUtil(ctx);	
		
		dbUtil.open();
			Cursor cursor = dbUtil.fetchThumb(Integer.parseInt(getid));
			pidlist = new String[cursor.getCount()];
			int i = 0;
			while(cursor.moveToNext()){				
				pidlist[i] = cursor.getString(0);
				i = i + 1;
			}
			cursor.close();
		dbUtil.close(); 		
        return pidlist;
    }
    
	private static String pimagelist[];
    protected static String[] GetImageData(Context ctx, String getid) {    	
    	DatabaseUtil dbUtil = new DatabaseUtil(ctx);	
		
		dbUtil.open();
			Cursor cursor = dbUtil.fetchThumb(Integer.parseInt(getid));
			pimagelist = new String[cursor.getCount()];
			int i = 0;
			while(cursor.moveToNext()){
				pimagelist[i] = cursor.getString(4);
				i = i + 1;
			}
			cursor.close();
		dbUtil.close(); 		
        return pimagelist;
    }
    
	private static String pupdatedlist[];
    protected static String[] GetUpdateData(Context ctx, String getid) {    	
    	DatabaseUtil dbUtil = new DatabaseUtil(ctx);	
		
		dbUtil.open();
			Cursor cursor = dbUtil.fetchThumb(Integer.parseInt(getid));
			pupdatedlist = new String[cursor.getCount()];
			int i = 0;
			while(cursor.moveToNext()){
				pupdatedlist[i] = cursor.getString(2);
				i = i + 1;
			}
			cursor.close();
		dbUtil.close(); 		
        return pupdatedlist;
    }
    
	private static String ptitlelist[];
    protected static String[] GetTitleData(Context ctx, String getid) {    	
    	DatabaseUtil dbUtil = new DatabaseUtil(ctx);	
		
		dbUtil.open();
			Cursor cursor = dbUtil.fetchThumb(Integer.parseInt(getid));
			ptitlelist = new String[cursor.getCount()];
			int i = 0;
			while(cursor.moveToNext()){
				ptitlelist[i] = cursor.getString(1);
				i = i + 1;
			}
			cursor.close();
		dbUtil.close(); 		
        return ptitlelist;
    }
    
	private static String pstorylist[];
    protected static String[] GetStoryData(Context ctx, String getid) {    	
    	DatabaseUtil dbUtil = new DatabaseUtil(ctx);	
		
		dbUtil.open();
			Cursor cursor = dbUtil.fetchThumb(Integer.parseInt(getid));
			pstorylist = new String[cursor.getCount()];
			int i = 0;
			while(cursor.moveToNext()){
				pstorylist[i] = cursor.getString(3);
				i = i + 1;
			}
			cursor.close();
		dbUtil.close(); 		
        return pstorylist;
    }
    
    static int mod(int x, int y)
    {
        int result = x % y;
        if (result < 0)
            result += y;
        return result;
    }    
}
